import java.awt.EventQueue;

import javax.imageio.ImageIO;
import javax.swing.JFrame;

import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import java.awt.Font;
import javax.swing.text.*;

import javax.swing.JButton;
import java.awt.Color;
import java.awt.SystemColor;
import java.awt.TextArea;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.awt.Graphics2D;
import java.io.IOException;

import javax.swing.JLabel;
import java.awt.geom.Rectangle2D;
import java.awt.FontMetrics;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;

public class GUI {

	private JFrame frmVcGbaBannericon;

	Methods method = new Methods();
	private JTextField txtTitleForBanner;
	private JTextField titleOne;
	private JTextField titleTwo;

	BufferedImage banner2Base = null;
	BufferedImage banner2 = null;

	String title1 = "";
	String title2 = "";		
	Rectangle2D f1 = null;
	Rectangle2D f2 = null;
	Color textColor = new Color(89, 89, 89);
	AbstractDocument doc;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					GUI window = new GUI();
					window.frmVcGbaBannericon.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});


	}



	/**
	 * Create the application.
	 */
	public GUI() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmVcGbaBannericon = new JFrame();
		frmVcGbaBannericon.setTitle("VC GBA Banner/Icon Creator");
		frmVcGbaBannericon.setResizable(false);
		frmVcGbaBannericon.setBackground(Color.WHITE);
		frmVcGbaBannericon.setBounds(100, 100, 561, 425);
		frmVcGbaBannericon.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmVcGbaBannericon.getContentPane().setLayout(null);

		final TextArea status = new TextArea();
		status.setEditable(false);
		status.setBounds(20, 237, 250, 126);
		frmVcGbaBannericon.getContentPane().add(status);

		final JLabel imageLabel = new JLabel("");
		imageLabel.setBackground(Color.WHITE);
		imageLabel.setBounds(10, 45, 250, 186);
		frmVcGbaBannericon.getContentPane().add(imageLabel);

		JButton loadImage = new JButton("Load Image");
		loadImage.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {

				method.pickImage();
				status.setText(method.text);
				imageLabel.setIcon(new ImageIcon(method.userImage1));
			}
		});

		loadImage.setToolTipText("Please chose an image for banner creation.");
		loadImage.setBackground(SystemColor.menu);
		loadImage.setBounds(10, 11, 176, 23);
		frmVcGbaBannericon.getContentPane().add(loadImage);

		JButton clearButton = new JButton("Clear");
		clearButton.setBackground(SystemColor.menu);
		clearButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				status.setText("");
			}
		});



		clearButton.setBounds(10, 369, 83, 23);
		frmVcGbaBannericon.getContentPane().add(clearButton);

		final JButton createButton = new JButton("Create and Save Images");
		createButton.addMouseListener(new MouseAdapter() {

			@Override
			public void mouseClicked(MouseEvent arg0) {

				final JFrame parent = new JFrame();

				try {

					if (method.userImage1 == null) {
						JOptionPane.showMessageDialog(parent, "Please load an image");
					} else if (titleTwo.getText().equals("") & titleOne.getText().equals("")) {
						JOptionPane.showMessageDialog(parent, "Please enter the title of the game");
					} else {

						method.createFolder();
						method.createBanner1(method.userImage1, 118, 78);
						status.setText(method.text);
						method.createIcon(method.userImage2, 40, 29);
						status.setText(method.text);
						createBanner2();
						status.setText(method.text);
						method.text = method.text + "DONE!" + '\n';
						status.setText(method.text);

					}

				} catch (Exception e) {
					JOptionPane.showMessageDialog(parent, "Error");
				}

			}
		});
		createButton.setToolTipText("Please chose an image for banner creation.");
		createButton.setBackground(SystemColor.menu);
		createButton.setBounds(196, 11, 176, 23);
		frmVcGbaBannericon.getContentPane().add(createButton);

		txtTitleForBanner = new JTextField();
		txtTitleForBanner.setEditable(false);
		txtTitleForBanner.setText("Title for Banner2 image");
		txtTitleForBanner.setBounds(394, 11, 151, 22);
		frmVcGbaBannericon.getContentPane().add(txtTitleForBanner);
		txtTitleForBanner.setColumns(10);

		titleOne = new JTextField();
		titleOne.setBounds(270, 45, 275, 20);
		frmVcGbaBannericon.getContentPane().add(titleOne);
		titleOne.setColumns(10);
		titleOne.setDocument(new JTextFieldLimit(24));

		titleTwo = new JTextField();
		titleTwo.setColumns(10);
		titleTwo.setBounds(270, 66, 275, 20);
		frmVcGbaBannericon.getContentPane().add(titleTwo);
		titleTwo.setDocument(new JTextFieldLimit(24));

		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(282, 100, 263, 263);
		frmVcGbaBannericon.getContentPane().add(scrollPane);

		JTextArea message = new JTextArea();
		message.setEditable(false);
		message.setFont(new Font("Arial", Font.PLAIN, 13));
		message.setLineWrap(true);
		message.setWrapStyleWord(true);
		message.setText("Copy/Pasta if you need any of these\r\n\u00E1 \u00E9 \u00ED \u00F3 \u00FA \u00F1 \u00FC \u00A1 \u00BF \r\n\r\nWARNING: If you click the Create and Save Images button multiple times before loading a new image, it will ruin your banner1 and icon image, so click once and everything should be fine.  Will work on a fix. Meanwhile, just load the image again if you clicked twice.\r\n\r\nMake sure the .jar file is in its own folder. This is for organizational purposes. The program will generate a folder with the same name as the image you provided. This folder will contain your images once they are created.\r\n\r\nStep 1: Obtain a title screen image of the gba game you want banners for.\r\n\r\nStep 2: Click \"Load Image\" and select the image you want to use.\r\n\r\nStep 3: Enter the title of the game into the input boxes above this message box. If you want  the title on a single line on the banner, use only the top box. If you want to split it up on two lines, use both.\r\n\r\nStep 4: Click \"Create and Save Images\", A folder will be created in the same folder where  the .jar file is. This folder will contain your images. \r\n\r\nDONE!");
		scrollPane.setViewportView(message);

	}

	public BufferedImage createBanner2() {

		method.saveName = "banner2.png";
		title1 = titleOne.getText();
		title2 = titleTwo.getText();
		int fontSize = 0;

		try {

			if (title1.length() <= 18) {
				fontSize = 16;

			} else {
				fontSize = 12;
			}
			
			Font font = new Font("Arial", Font.BOLD, fontSize);
			banner2Base = ImageIO.read(getClass().getResource("banner2Template.png"));
			banner2 = new BufferedImage (banner2Base.getWidth(), banner2Base.getHeight(), BufferedImage.TYPE_INT_ARGB);
			Graphics2D ban2 = banner2.createGraphics(); 
			FontMetrics metrics1 = ban2.getFontMetrics();
			ban2.setFont(font); 
			f1 = font.getStringBounds(title1, ban2.getFontRenderContext());
			ban2.setColor(textColor);
			ban2.drawImage(banner2Base, 0, 0, null);

			if (titleTwo.getText().equals("")) {
				ban2.drawString(title1, (int) (174 - f1.getWidth() / 2), 32 + metrics1.getAscent() / 2);


			} else {
				f2 = font.getStringBounds(title2, ban2.getFontRenderContext());
				ban2.drawString(title1, (int) (174 - f1.getWidth() / 2), 24 + metrics1.getAscent() / 2);
				ban2.drawString(title2, (int) (174 - f2.getWidth() / 2), 40 + metrics1.getAscent() / 2);
			}

			method.text = method.text +  method.saveName + " draw title" + '\n';
			ban2.dispose();
		} catch (IOException e) {
			e.printStackTrace();
			method.text = method.text +  method.saveName + " draw title fail" + '\n';
		}
		method.saveImage(banner2);
		return banner2; 

		//Middle of line 1 when there are 1 lines of text: 174, 32

		//Middle of line 1 when there are two lines of text: 174, 24
		//Middle of line 2 when there are two lines of text: 174, 40


	}
}
