import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.filechooser.FileNameExtensionFilter;

import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Path;

public class Methods {

	File imageFile = null;
	String text = "";

	BufferedImage userImage1 = null;
	BufferedImage userImage2 = null;
	String saveName = "";
	File folder = null;
	
	public void createFolder() {

		String folderName = imageFile.getName();
		folderName = folderName.replace(".png", "");
		folderName = folderName.replace(".jpeg", "");
		folderName = folderName.replace(".gif", "");
		folder = new File(folderName);

		if (!folder.exists()) {
			text = text + "creating directory: " + folderName + '\n';

			folder.mkdir();
			text = text + "folder created" + '\n';

		} else {

			text = text + "folder already exists" + '\n';
			
		}

	}
	
	//this method allows to choose an image for banner creation
	public void pickImage() {

		JFileChooser chooser = new JFileChooser();

		FileNameExtensionFilter filter = new FileNameExtensionFilter(
				"JPG & GIF & PNG Images", "jpg", "gif", "png");
		chooser.setFileFilter(filter);
		int returnVal = chooser.showOpenDialog(new JFrame());
		if(returnVal == JFileChooser.APPROVE_OPTION) {

			imageFile = chooser.getSelectedFile();
			try {

				userImage1 = ImageIO.read(imageFile);		
				userImage2 = userImage1;	
				text = text + chooser.getSelectedFile().getName() + " loaded" + '\n';

			} catch (IOException e1) {
				e1.printStackTrace();
				text = text + chooser.getSelectedFile().getName() + " load fail" + '\n';
			}

		}
	}

	//This method saves the finished product
	public void saveImage(BufferedImage bufferedImage) {

		//JFileChooser chooser = new JFileChooser();
		File outputfile = new File(folder.getName() + "//" + saveName);
		
		try { 
			ImageIO.write(bufferedImage, "png", outputfile);
			text = text +  saveName + " saved" + '\n';
		} catch (IOException e) {
			e.printStackTrace();
			text = text +  saveName + " save fail" + '\n';
		}

	}



	//This method creates the Banner1 image
	public BufferedImage createBanner1(BufferedImage img, int newW, int newH) {

		saveName = "banner1.png";
		BufferedImage mainImage = null;  
		BufferedImage purpleOutline = null;
		BufferedImage banner1 = null;
		int w = userImage1.getWidth();
		int h = userImage1.getHeight();

		try {
			purpleOutline = ImageIO.read(getClass().getResource("Purple_Outline.png"));
			banner1 = new BufferedImage (128, 128, BufferedImage.TYPE_INT_ARGB);
			mainImage = new BufferedImage (newW, newH, img.getType());	
			Graphics2D banner = banner1.createGraphics();  
			Graphics2D main = mainImage.createGraphics();  
			banner.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR); 
			main.drawImage(img, 0, 0, newW, newH, 0, 0, w, h, null); 
			text = text +  saveName + " resized" + '\n';
			banner.drawImage(mainImage, 64 - mainImage.getWidth() / 2, 64 - mainImage.getHeight() / 2, null);
			banner.drawImage(purpleOutline, 64 - purpleOutline.getWidth() / 2, 64 - purpleOutline.getHeight() / 2, null);
			text = text +  saveName + " added purple outline" + '\n';
			banner.dispose(); 
			main.dispose();

		} catch (IOException e) {
			e.printStackTrace();
			text = text +  saveName + " add purple outline fail" + '\n';
		}

		userImage1 = banner1;
		saveImage(userImage1);
		userImage1 = userImage2;
		return banner1; 
	}

	public BufferedImage createIcon(BufferedImage img2, int newW2, int newH2) {

		BufferedImage mainI = null;
		BufferedImage outline = null;
		BufferedImage icon = null;
		saveName = "icon.png";

		int w = userImage2.getWidth();
		int h = userImage2.getHeight();

		try {

			mainI = new BufferedImage (newW2, newH2, img2.getType());
			outline = ImageIO.read(getClass().getResource("Icon_Background.png"));
			icon = new BufferedImage (outline.getWidth(), outline.getHeight(), BufferedImage.TYPE_INT_ARGB);
			Graphics2D main2 = mainI.createGraphics(); 
			Graphics2D ICON = icon.createGraphics();
			main2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
			main2.drawImage(img2, 0, 0, newW2, newH2, 0, 0, w, h, null);
			text = text +  saveName + " resized" + '\n';
			ICON.drawImage(outline, 0, 0, null);
			ICON.drawImage(mainI, 4, 9, null);
			text = text +  saveName + " added outline" + '\n';
			main2.dispose();
			ICON.dispose();			

		} catch (IOException e) {
			e.printStackTrace();
			text = text +  saveName + " add outline fail" + '\n';
		}

		userImage2 = icon; 
		saveImage(userImage2);
		return icon;

	}
	
}
